function NFmsgSend()
{}

NFmsgSend.prototype = { // a fully encapsulated sending class
    reply: 1,
    forward: 2,
    sendType: '',
    stdResponse: '',
    origMsgHdr: '',
    fwdTo: '',
    params: '',
    compfields: '',
    msgCompose: '',
    editorElement: '',
    editor: '',
    tempEditorWindow: '',
    sAccountManager: '',
    msgEditorCreationObserver: {  
            instnce: '',
            observe: function(aSubject, aTopic, aData) {
                // This function is triggered when a new editor has been created
                if (aTopic == "obs_documentCreated") {
                    var instance = this.instnce;
                    instance.getEditor(instance);
                    if (instance.editor) {
                        instance.msgCompose.initEditor(instance.editor, window.content);
                        setTimeout(instance.sendMsg,200,instance);
                    }
                }
            }
        },

    initSend: function(typ,msgHdr,response,fwdTo) {
            this.origMsgHdr = msgHdr;
            this.stdResponse = response;
            this.originalMsgURI = msgHdr.folder.getUriForMsg(msgHdr)
            this.params = Components.classes["@mozilla.org/messengercompose/composeparams;1"].createInstance(Components.interfaces.nsIMsgComposeParams);
            this.compfields = Components.classes["@mozilla.org/messengercompose/composefields;1"].createInstance(Components.interfaces.nsIMsgCompFields);
            this.msgCompose = Components.classes["@mozilla.org/messengercompose/compose;1"].createInstance(Components.interfaces.nsIMsgCompose);
            this.sAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
            this.params.identity = this.getCurrentIdentity(this);
            this.params.format = 2;	// makes things less difficult
            this.compfields.otherRandomHeaders +="X-AutomatedSend: yes\r\n";
            this.params.originalMsgURI = this.originalMsgURI;
            if (typ == 1) { // 1 is reply, 2 is forward
                this.params.composeFields = this.compfields;
                this.params.type = 1;
                this.sendType = 1;
            } else {
                this.fwdTo = fwdTo;
                this.compfields.to = this.fwdTo;
                this.compfields.replyTo = msgHdr.author;
                this.params.composeFields = this.compfields;
                this.params.type = 3;
                this.sendType = 2;
            }
            this.tempEditorWindow = window.open("chrome://newfilt/content/NFeditor.xul", "_blank", "chrome,extrachrome,centerscreen");
            setTimeout(this.setUpEditor,20,this);
        },    
    getEditor: function(instance) {
            instance.editor = instance.editorElement.getEditor(instance.editorElement.contentWindow);
            instance.editor instanceof Components.interfaces.nsIPlaintextEditor;
            instance.editor instanceof Components.interfaces.nsIHTMLEditor;
        },
    setUpEditor: function(instance) {
            try{
                var editorList = instance.tempEditorWindow.document.getElementsByTagName("editor");
                if (editorList.item(0))
                instance.editorElement = editorList.item(0);
            } catch(e) {
                alert('get editor element error, ' + e);
                return;
            }
            instance.editorElement.makeEditable("textmail", true);
            instance.editorElement.webNavigation.loadURI("about:blank", // uri string
                                   0,                            // load flags
                                   null,                         // referrer
                                   null,                         // post-data stream
                                   null);
            instance.msgCompose.Initialize(instance.tempEditorWindow, instance.params );
            instance.msgEditorCreationObserver.instnce = instance;
            instance.editorElement.commandManager.addCommandObserver(instance.msgEditorCreationObserver, "obs_documentCreated");
        },
    getCurrentIdentity: function(instance) {
            var identity = '';
            try{
                var server = instance.origMsgHdr.folder.server; 
        	    var identity = instance.sAccountManager.getFirstIdentityForServer( server );
        	} catch(e) {}
            // if identity is still blank, lets use the one from prefs - Frank DiLecce
        	if (!identity) { identity = instance.sAccountManager.getIdentity("id1") };
        	return identity;
        },
    sendMsg: function(instance) {
            instance.editor.rootElement.innerHTML = instance.stdResponse;
            instance.editorElement.commandManager.removeCommandObserver(instance.msgEditorCreationObserver, "obs_documentCreated");
            var account =  instance.sAccountManager.FindAccountForServer(GetLoadedMsgFolder().server);
            msgWindow.SetDOMWindow(window);
            var deliverMode = Components.interfaces.nsIMsgCompDeliverMode
            var ident = instance.getCurrentIdentity(instance);
            instance.cleanUp(instance);
            instance.msgCompose.SendMsg(deliverMode.Now, ident, account.key, msgWindow, null);
        },
    cleanUp: function(instance) {
            instance.sendType = null;
            instance.stdResponse = null;
            instance.origMsgHdr = null;
            instance.fwdTo = null;
            instance.params = null;
            instance.compfields = null;
            instance.editorElement = null;
            instance.editor = null;
            instance.tempEditorWindow = null;
            instance.sAccountManager = null;
        }
}

function NFsearchNotificationListener()
{}

NFsearchNotificationListener.prototype = {
    testedHeader: '',
    isAuto: '',
    session: '',
    fwdTo: '',
    response: '',
    sendType: '',
    onSearchHit: function(header, folder){
        if (this.testedHeader == header) {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - SearchL, found X-AutomatedSend header entry in > ' + header.messageId);
            this.isAuto = true;            
        }
    },
    onSearchDone: function(status) {
        var rslt = "was NOT"
        if (this.isAuto) rslt = "WAS";
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - SearchL , searched > ' + 
            this.testedHeader.messageId + ' and found that the message ' + rslt + ' an automated message.');            
        this.session.unregisterListener(this);
        if (!this.isAuto) {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - SearchL, sending msg in response to message id>' + this.testedHeader.messageId + '<');
            setTimeout(NFglobals.sendMsgNow,1,this.sendType,this.testedHeader,this.response,this.fwdTo);
        }
    },
    onNewSearch: function() {
    }
}

var NFglobals = {
    temp1: '',
    temp2: '',
    temp3: '',
    temp4: '',
    temp5: '',
    temp6: '',
    temp7: '',
    temp8: '',
    temp9: '',
    temp10: '',
    sPrefs: '',
    debug: false,
    // below for autoreply-autoforward support
    sendMsgNow: function(type,hdr,response,fwdAddr) {
            var MS = new NFmsgSend();
            MS.initSend(type,hdr,response,fwdAddr);
    },
    // above for autoreply-autoforward support
    copyStack: '',
    autoRpyStack: '',
    autoFwdStack: '',
    idxCopyInProgress: 0,
    mailSession: '',    
    notifyFlags: '',
    consoleService: Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService),
    isDoneTimer: null,
    hdrArr: [''],
    hdrPreFilterArr: [''],
    newFilters: [''],
    folderListener: { 
        // this listener listens for New messages arriving
        OnItemAdded: function(parentItem, item, view) {
            try {
                try {
                    var ihdr = item.QueryInterface(Components.interfaces.nsIMsgDBHdr);
                } catch(e) {
                    return;
                }
                var ifdr = parentItem.QueryInterface(Components.interfaces.nsIMsgFolder);
                if (view == 'flatMessageView' && ihdr.flags & 65536) {
                    try {
                        NFglobals.debug = NFglobals.sPrefs.getBoolPref("newfilt.debug");
                    } catch(e) {
                        NFglobals.debug = false;
                        NFglobals.sPrefs.setBoolPref("newfilt.debug",NFglobals.debug);
                    }                
                    if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - folderListener ItemAdded triggered' +
                        ':\nparentItem.URI>' + ifdr.URI + 
                        '<\n          item>' + ihdr.subject + 
                        '<\n          view>' + view + 
                        '<\n      msgflags>' + ihdr.flags + '<');
                    if (ifdr.prettyName != 'Trash' && ifdr.prettyName != 'Junk' && ifdr.prettyName != 'Drafts') {
                        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - added new message' +
                            ':\nmessageId>' + ihdr.messageId  + '< to newfilter message array');
                        if (NFglobals.hdrArr[0] == '') {
                            NFglobals.hdrArr[0] = ihdr;
                        } else {
                            NFglobals.hdrArr[NFglobals.hdrArr.length] = ihdr;
                        }
                        if (!NFglobals.isDoneTimer) {
                            NFglobals.isDoneTimer = setTimeout(NFglobals.isGMdone,500); //,ifdr.server)
                        }
                    } else {
                        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - did NOT add new message' +
                            ':\nmessageKey>' + ihdr.messageKey  + '< to newfilter message array because it was deposited in the ' + 
                            ifdr.prettyName + ' folder');
                    }
                }
            } catch(e) {
                if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - folderListener ItemAdded - caught error' +
                ':\n          e>' + e + 
                '<\n parentItem>' + parentItem + 
                '<\n       item>' + item + 
                '<\n       view>' + view + '<');
            }
        },
        OnItemRemoved: function(parentItem, item, view) {
        },
        OnItemPropertyChanged: function(item, property, oldValue, newValue) {
        },
        OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {
        },
        OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {
        },
        OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue){
        },
        OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {
        },
        OnItemEvent: function(folder, event) {  
            var ifdr = folder.QueryInterface(Components.interfaces.nsIMsgFolder);
            var eventType = event.toString();
            if (eventType == 'DeleteOrMoveMsgCompleted' && NFglobals.idxCopyInProgress > 0) {
                if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - folderListener ItemEvent triggered' +
                ':\nfolder>' + ifdr.URI + 
                '<\n event>' + event + '<');
                NFglobals.doCopy(NFglobals.idxCopyInProgress + 1)
            }      
        }
    },

    isGMdone: function() {
        var allDone = true;
        var aM = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
        for (var i=0;i<aM.allServers.Count();i++) {
            try{
                var currentServer = aM.allServers.GetElementAt(i).QueryInterface(Components.interfaces.nsIMsgIncomingServer);
                if (currentServer.serverBusy) {
                    if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - isGMdone? NO- server>' + currentServer.prettyName + '< is still busy');
                    allDone = false;
                    break;
                }
            } catch(e) {
                tconsoleService.logStringMessage('newFilters - isGMdone-caught error >' + e + '<');
            }
        }
        if (allDone) {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - isGMdone? YES, running filters now');
            NFglobals.isDoneTimer = null;
            NFglobals.setFilters();
            setTimeout(NFglobals.filterMsgs,1);
        } else { // lets try again
            NFglobals.isDoneTimer = setTimeout(NFglobals.isGMdone,500);
        }    
    },

    setFilters: function() {
        var sfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        try {
        	var filtersFileName = NFglobals.sPrefs.getCharPref( 'newfilt.file');
        } catch (e) {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - setFilters, filter fileName not set in prefs, aborting');
            return;
        }
        NFglobals.newFilters = [''];
        try {
            sfile.initWithPath(filtersFileName);
            var fileInputStream =  Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
            fileInputStream.init( sfile, 0x01, 0444, null );
            var fileScriptableIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
            fileScriptableIO.init(fileInputStream);
            var fileContent = fileScriptableIO.read( sfile.fileSize - 1);
            fileScriptableIO.close();
            fileInputStream.close();
            var re = /\r/gi;
            fileContent = fileContent.replace(re,'');
            var re = /\n/gi;
            var tempArray = fileContent.split(re);
            var filtIdx = -1;
            var condIdx = 0;
            var actnIdx = 0;
            for ( var index = 0; index < tempArray.length; index++) {
                if (tempArray[index].substring(0,5) == 'name=') {
                    var val = tempArray[index].substr(5)
                    var re = /"/gi;
                    val = val.replace(re,'');
                    if (filtIdx > -1) {
                        NFglobals.newFilters[filtIdx] = dfilt;
                    }
                    var action = { aType: '', aValue: ''}
                    var actions = [action];
                    var condition = {arbHdr: '', boolAnd: '', op: '', sValue: ''};
                    var conditions = [condition];
                    var dfilt = { name: '', conditions: conditions, actions: actions, enabled: '', fType: ''};
                    dfilt.name = val;
                    var condIdx = 0;
                    var actnIdx = 0;
                    filtIdx++;
                }
                if (tempArray[index].substring(0,10) == 'condition=') {
                    var cond = tempArray[index].substr(10);
                    var pos = 10;
                    while (cond.length > 2) {
                        if (dfilt.conditions[condIdx] == null) {
                            var condition = {arbHdr: '', boolAnd: '', op: '', sValue: ''};
                            dfilt.conditions[condIdx] = condition;
                        }
                        if (cond.substring(1,3) == "OR" ) {
                            dfilt.conditions[condIdx].boolAnd = false; 
                        } else { 
                            dfilt.conditions[condIdx].boolAnd = true; 
                        }
                        var cEnd = cond.indexOf(')');
                        pos = cEnd + pos + 1;
                        var cond = cond.substr(cond.indexOf('(') +1);
                        var cond = cond.substring(0,cond.indexOf(')'));
                        var conds = cond.split(',');
                        var cond = tempArray[index].substr(pos);
                        var re = /"/gi;
                        conds[0] = conds[0].replace(re,'');
                        dfilt.conditions[condIdx].arbHdr = conds[0]; 
                        var re = /"/gi;
                        conds[1] = conds[1].replace(re,'');
                        dfilt.conditions[condIdx].op = conds[1]; 
                        var re = /"/gi;
                        conds[2] = conds[2].replace(re,'');
                        dfilt.conditions[condIdx].sValue = conds[2]; 
                        condIdx++
                    }
                }
                if (tempArray[index].substring(0,5) == 'type=') {
                    var val = tempArray[index].substr(5)
                    var re = /"/gi;
                    val = val.replace(re,'');
                    dfilt.fType = val;
                }
                if (tempArray[index].substring(0,7) == 'action=') {
                    if (dfilt.actions[actnIdx] == null) {
                        var action = { aType: '', aValue: ''}
                        dfilt.actions[actnIdx] = action;
                    }
                    var val = tempArray[index].substr(7)
                    var re = /"/gi;
                    val = val.replace(re,'');
                    dfilt.actions[actnIdx].aType = val;
                }
                if (tempArray[index].substring(0,8) == 'enabled=') {
                    var val = tempArray[index].substr(8)
                    var re = /"/gi;
                    val = val.replace(re,'');
                    dfilt.enabled = false;
                    if (val == 'yes') dfilt.enabled = true;
                }
                if (tempArray[index].substring(0,12) == 'actionValue=') {
                    var val = tempArray[index].substr(12)
                    var re = /"/gi;
                    val = val.replace(re,'');
                    dfilt.actions[actnIdx].aValue = val;
                    actnIdx++
                }
            }
            NFglobals.newFilters[filtIdx] = dfilt;
        } catch(e) {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - setFilters caught error e>' + e);
        }
    },

    chkAgHdr: function(filt, hdr, actn, hdrIdx) {
        //if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - chkAgHdr, start');
        try {
            for (var m = 0; m < filt.conditions.length; m++) {
                var arbhdr = '';
                var rslt = '';
                arbhdr = hdr.getStringProperty(filt.conditions[m].arbHdr);
                if (filt.conditions[m].op == 'contains') rslt = (arbhdr.indexOf(filt.conditions[m].sValue) != -1) 
                if (filt.conditions[m].op == "doesn't contain") rslt = (arbhdr.indexOf(filt.conditions[m].sValue) == -1);
                if (filt.conditions[m].op == "is") rslt = (arbhdr == filt.conditions[m].sValue);
                if (filt.conditions[m].op == "isn't") rslt = (arbhdr != filt.conditions[m].sValue);
                if (filt.conditions[m].op == "begins with") rslt = (arbhdr.substring(0,filt.conditions[m].sValue.length) == filt.conditions[m].sValue);
                if (filt.conditions[m].op == "ends with") rslt = (arbhdr.substring(filt.conditions[m].sValue.length) == filt.conditions[m].sValue);
                if (filt.conditions[m].op == "is") rslt = (arbhdr == filt.conditions[m].sValue);
                //if (filt.conditions[m].op == "is in my Address book") xxx TODO xxx;  ( for sender, to, cc, to or cc )
                //if (filt.conditions[m].op == "isn't in my Address book") xxx TODO xxx;( for sender, to, cc, to or cc )
                //if (filt.conditions[m].op == "is greater than") xxx TODO xxx;( for priority, age in days )
                //if (filt.conditions[m].op == "is less than") xxx TODO xxx;( for priority, age in days)
                if (rslt) {
                    for (var n = 0; n < filt.actions.length; n++) {
                        if (actn[n] == null) {
                            var action = {actnType: 0, value: ''};
                            actn[n] = action;
                        }
                        actn[n].actnType = filt.actions[n].aType;
                        actn[n].value = filt.actions[n].aValue;
                        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - chkAgHdr- Filter Hit ! ' + 
                            ':\nfilter     >' + filt.conditions[m].arbHdr + '...' + filt.conditions[m].op + '...' + filt.conditions[m].sValue + 
                            '<\nactionType >' + filt.actions[n].aType + 
                            '<\nactionValue>' + filt.actions[n].aValue + '<');
                    }
                }
            }
        } catch(e) {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - chkAgHdr-caught error >' + e + '< index>' + hdrIdx + '<');
        }
    },

    filterMsgs: function() {
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - filterMsgs, start');
        var sndA = [''];
        var sndAi = 0;
        var cpyA = [''];
        var cpyAi = 0;
        var rpyA = [''];
        var rpyAi = 0;
        var fwdA = [''];
        var fwdAi = 0;
        for (var i = 0; i < NFglobals.hdrArr.length; i++) {
            try {
                for (var k = 0; k < NFglobals.newFilters.length; k++) {
                    var action = {actnType: 0, value: ''};
                    var actions = [action];
                    NFglobals.chkAgHdr(NFglobals.newFilters[k],NFglobals.hdrArr[i],actions, i);
                    for (var m = 0; m < actions.length; m++) {
                        switch (actions[m].actnType) {
                            case "Play Sound": // play sounds
                                // gotta see if that sound is in the array of sounds to play already
                                var tsnd = actions[m].value; //this should be in the form of 'file:///C:/Subfolder/Subfolder%20With%20Space/soundfile.wav'
                                var isThere = false;
                                for (var j = 0; j < sndA.length; j++) {
                                    if (sndA[j] == tsnd) {isThere = true; break;}
                                }
                                if (!isThere) {sndA[sndAi++] = tsnd;}                    
                                break;
                            case "Copy To Folder": // copy messages
                                // we are just going to add the details to an array, we will sort out the order of copying later
                                var cpyMsg = {srcFldr: '', toFldr: '', hdr: '', copied: false};
                                cpyA[cpyAi] = cpyMsg;
                                cpyA[cpyAi].hdr = NFglobals.hdrArr[i];
                                cpyA[cpyAi].srcFldr = NFglobals.hdrArr[i].folder;
                                cpyA[cpyAi].toFldr = actions[m].value;  //this should be in the form of 'mailbox://nobody@Local%20Folders/Inbox/subfolder%%optional next folder'
                                if (actions[m].value.indexOf('%%') != -1) {
                                    var toFldrs = actions[m].value.split('%%');
                                    cpyA[cpyAi].toFldr = toFldrs[0];
                                    for (var j = 0; j < toFldrs.length; j++) {
                                        var cpyMsg = {srcFldr: '', toFldr: '', hdr: '', copied: false};
                                        cpyAi++;
                                        cpyA[cpyAi] = cpyMsg;
                                        cpyA[cpyAi].hdr = NFglobals.hdrArr[i];
                                        cpyA[cpyAi].srcFldr = NFglobals.hdrArr[i].folder;
                                        cpyA[cpyAi].toFldr = toFldrs[j];
                                    }
                                }
                                cpyAi++;
                                break;
                            case "AutoReply": // auto-reply to message
                                // we are just going to add the details to an array, we will sort out the order of replying later
                                var rpyMsg = {srcFldr: '', deets: '', hdr: '', done: false};
                                rpyA[rpyAi] = rpyMsg;
                                rpyA[rpyAi].hdr = NFglobals.hdrArr[i];
                                rpyA[rpyAi].srcFldr = NFglobals.hdrArr[i].folder;
                                rpyA[rpyAi++].deets = actions[m].value;  //this should be in the form of autoreplyresponse as a text string
                                break;
                            case "AutoForward": // auto-forward a message
                                var fwdMsg = {srcFldr: '', deets: '', hdr: '', done: false};
                                fwdA[fwdAi] = fwdMsg;
                                fwdA[fwdAi].hdr = NFglobals.hdrArr[i];
                                fwdA[fwdAi].srcFldr = NFglobals.hdrArr[i].folder;
                                fwdA[fwdAi++].deets = actions[m].value;  //this should be in the form of xxx@yyy.org%%optional forward text
                                break;
                            default: 
                                break;
                        }    
                    }
                }
            } catch(e) {
                if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - filterMsgs-caught error >' + e + '<');
            }
        }
        setTimeout(NFglobals.playSound,1,sndA,0);
        NFglobals.copyStack = [''];
        setTimeout(NFglobals.copyTheMessages,1,cpyA,0);    
        NFglobals.autoRpyStack = [''];
        setTimeout(NFglobals.autoReplyMessages,1,rpyA,0)
        NFglobals.autoFwdStack = [''];
        setTimeout(NFglobals.autoForwardMessages,1,fwdA,0)
        NFglobals.hdrArr = [''];
        NFglobals.hdrPreFilterArr = [''];
    },

    postFilterMsg: function (hdr,sendType,fwdToAddr,response) {
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - postFilterMsgs, starting to test if this message is an automated response.');
        var SearchSession = Components.classes["@mozilla.org/messenger/searchSession;1"].createInstance(Components.interfaces.nsIMsgSearchSession);
        SearchSession.addScopeTerm(hdr.folder.server.searchScope,hdr.folder);
        var trm = SearchSession.createTerm()
        trm.arbitraryHeader = 'X-AutomatedSend';
        trm.attrib = Components.interfaces.nsMsgSearchAttrib.OtherHeader;  //49, arbitrary header attribute
        trm.op = Components.interfaces.nsMsgSearchOp.Is;  //2, 'is' op
        stri = trm.value;
        stri.str = 'yes';
        trm.value = stri;
        SearchSession.appendTerm(trm);
        var NSF = new NFsearchNotificationListener;
        NSF.fwdTo = fwdToAddr;
        NSF.sendType = sendType;
        NSF.response = response;
        NSF.testedHeader = hdr;
        NSF.session = SearchSession;
        SearchSession.registerListener(NSF);
        SearchSession.search(msgWindow);
    },

    // this allows the extension to autoreply to multiple messages  
    autoForwardMessages: function(fwdArr, idx) {
        var fwdToMsg = fwdArr[idx];  
        if (fwdToMsg == '') {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoReplyMessages, all AutoForwards were processed');
            return;
        }
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoForwardMessages, idx >' + idx + '<');
        if (!fwdToMsg.done) {
            var sF = fwdToMsg.srcFldr; // get the source folder
            fwdArr[idx].done = true; // mark the item replied to
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoForwardMessages, setting message *handled*, details' +
                ':\nid    >' + fwdArr[idx].hdr.messageId + 
                '<\nfrom  >' + fwdArr[idx].hdr.mime2DecodedAuthor + 
                '<\naction>forwarded');
            // on forwards, we have to break up deets into address and message
            var details = fwdToMsg.deets.split('%%');
            if (details.length == 2) { 
                // Now check if the message has the AutomatedSend header item set
                NFglobals.postFilterMsg(fwdToMsg.hdr,2,details[0],details[1]);
            } else {
                if (NFglobals.debug) NFglobals.consoleService.logStringMessage("newFilters - autoForwardMessages, this filter's attributes are incorrect, skipping it");
            }
        }
        if (idx + 1 < fwdArr.length) {
            setTimeout(NFglobals.autoForwardMessages,200, fwdArr, idx + 1);
        } else {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoReplyMessages, all AutoForwards were processed');
        }
    },

    autoReplyMessages: function(rpyArr, idx) {
        var rpyToMsg = rpyArr[idx];  
        if (rpyToMsg == '') {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoReplyMessages, all AutoReplies were processed');
            return;
        }
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoReplyMessages, idx >' + idx + '<');
        if (!rpyToMsg.done) {
            var sF = rpyToMsg.srcFldr; // get the source folder
            var mAuthor = rpyToMsg.hdr.mime2DecodedAuthor;
            // get ALL of the other headers that match the author
            for (var j = 0; j < rpyArr.length; j++) {
                if (rpyArr[j].hdr.mime2DecodedAuthor == mAuthor) {
                    rpyArr[j].done = true; // mark the item replied to
                    if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoReplyMessages, setting message *handled*, details' +
                        ':\nid>' + rpyArr[j].hdr.messageId + 
                        '<\nfrom>' + rpyArr[j].hdr.mime2DecodedAuthor + 
                        '<\naction>replied to');
                }
            }
            // Now check if the message has the AutomatedSend header item set
            NFglobals.postFilterMsg(rpyToMsg.hdr,1,'',rpyToMsg.deets);
        }
        if (idx + 1 < rpyArr.length) {
            setTimeout(NFglobals.autoReplyMessages,200, rpyArr, idx + 1);
        } else {
            if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - autoReplyMessages, all AutoReplies were processed');
        }
    },

    // this allows the extension to copy multiple messages to any other folders 
    copyTheMessages: function(cpyArr, idx) {
        var cpyToFldr = cpyArr[idx];  
        if (cpyToFldr == '') return;
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters -  copyTheMessages, idx >' + idx + '<');
        if (!cpyToFldr.copied && cpyToFldr.toFldr != '') {
            var dF = cpyToFldr.toFldr; // get the destination folder
            var sF = cpyToFldr.srcFldr; // get the source folder
            // get ALL of the other headers that match
            var list = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
            for (var j = 0; j < cpyArr.length; j++) {
                if (cpyArr[j].toFldr == dF && cpyArr[j].srcFldr == sF) {
                    cpyArr[j].copied = true; // mark the item copied
                    list.AppendElement(cpyArr[j].hdr); // add to the list
                    if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters -  copyTheMessages, appended messageId>' + 
                    cpyArr[j].hdr.messageId + '<');
                }
            }
            dF = RDF.GetResource(dF).QueryInterface(Components.interfaces.nsIMsgFolder);
            var copyDeets = {dest: '', src: '', lst: '', mov: false};
            var cSlen = NFglobals.copyStack.length;
            NFglobals.copyStack[cSlen] = copyDeets;
            NFglobals.copyStack[cSlen].dest = dF;
            NFglobals.copyStack[cSlen].src = sF;
            NFglobals.copyStack[cSlen].lst = list;
        }
        if (idx + 1 < cpyArr.length) {
            setTimeout(NFglobals.copyTheMessages,200, cpyArr, idx + 1);
        } else {
            NFglobals.doCopy(1);
        }
    },
    
    doCopy: function(idx) {
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters -  doCopy start');
        if (idx == NFglobals.copyStack.length) {
            NFglobals.idxCopyInProgress = 0;
            return;
        }
        // this will copy each stack item. ( each item might contain more than one message
        // the folder listener will call docopy again when the copy completes (necessary)
        NFglobals.idxCopyInProgress = idx;
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - doCopy copying messages' +
            ':\n  to folder>' + NFglobals.copyStack[idx].dest.URI + 
            '<\nfrom folder>' + NFglobals.copyStack[idx].src.URI + '<');
        messenger.CopyMessages(GetFolderDatasource(), 
                                RDF.GetResource( NFglobals.copyStack[idx].src.URI), 
                                RDF.GetResource(NFglobals.copyStack[idx].dest.URI), 
                                NFglobals.copyStack[idx].lst, 
                                false);
    },
   
    //// this allows the extension to play multiple sounds, one after another 
    playSound: function(urlarr, idx) {
        var soundURL = urlarr[idx];  
        if (soundURL == '') return;
        var gSound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var url = ioService.newURI(soundURL, null, null);
        if (NFglobals.debug) NFglobals.consoleService.logStringMessage('newFilters - playSound-playing' +
            ':\nsoundfile>' + soundURL +'<');
        gSound.play(url)
        if (idx + 1 < urlarr.length) {
            setTimeout(NFglobals.playSound,800 , urlarr, idx + 1);
        }
    }
}
NFglobals.sPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
try {
    NFglobals.debug = NFglobals.sPrefs.getBoolPref("newfilt.debug");
} catch(e) {
    NFglobals.debug = false;
    NFglobals.sPrefs.setBoolPref("newfilt.debug",NFglobals.debug);
}
NFglobals.mailSession = Components.classes["@mozilla.org/messenger/services/session;1"].getService(Components.interfaces.nsIMsgMailSession);
NFglobals.notifyFlags = Components.interfaces.nsIFolderListener.all;
NFglobals.mailSession.AddFolderListener(NFglobals.folderListener, NFglobals.notifyFlags);

